GNU bug report logs - #13582
[PATCH] stat: add ext4 to the ext2/ext3 list

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: coreutils; Severity: wishlist; Reported by: Mike Frysinger <vapier@HIDDEN>; Keywords: patch; merged with #18264; dated Tue, 29 Jan 2013 06:15:01 UTC; Maintainer for coreutils is bug-coreutils@HIDDEN.
Forcibly Merged 13582 18264. Request was from Pádraig Brady <P@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 13582 <at> debbugs.gnu.org:


Received: (at 13582) by debbugs.gnu.org; 31 Jan 2013 09:22:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 31 04:22:17 2013
Received: from localhost ([127.0.0.1]:56864 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U0qLZ-0000DK-5Q
	for submit <at> debbugs.gnu.org; Thu, 31 Jan 2013 04:22:17 -0500
Received: from mx1.redhat.com ([209.132.183.28]:28897)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <ovasik@HIDDEN>) id 1U0qLW-0000DC-NR
	for 13582 <at> debbugs.gnu.org; Thu, 31 Jan 2013 04:22:16 -0500
Received: from int-mx02.intmail.prod.int.phx2.redhat.com
	(int-mx02.intmail.prod.int.phx2.redhat.com [10.5.11.12])
	by mx1.redhat.com (8.14.4/8.14.4) with ESMTP id r0V9GReJ028915
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Thu, 31 Jan 2013 04:16:27 -0500
Received: from [10.34.4.155] (unused-4-155.brq.redhat.com [10.34.4.155])
	by int-mx02.intmail.prod.int.phx2.redhat.com (8.13.8/8.13.8) with ESMTP
	id r0V9GPU2019782; Thu, 31 Jan 2013 04:16:26 -0500
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
From: Ondrej Vasik <ovasik@HIDDEN>
To: Bernhard Voelker <mail@HIDDEN>
In-Reply-To: <510A2527.2050407@HIDDEN>
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
	<20130130212750.GA23255@HIDDEN>
	<51099A07.6090704@HIDDEN>
	<20130130224418.GA10314@HIDDEN>
	<510A2527.2050407@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Organization: Red Hat, Inc.
Date: Thu, 31 Jan 2013 10:16:25 +0100
Message-ID: <1359623785.11109.50.camel@HIDDEN>
Mime-Version: 1.0
Content-Transfer-Encoding: 7bit
X-Scanned-By: MIMEDefang 2.67 on 10.5.11.12
X-Spam-Score: -4.7 (----)
X-Debbugs-Envelope-To: 13582
Cc: 13582 <at> debbugs.gnu.org, Bob Proulx <bob@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: ovasik@HIDDEN
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -7.4 (-------)

On Thu, 2013-01-31 at 09:02 +0100, Bernhard Voelker wrote:
> On 01/30/2013 11:44 PM, Bob Proulx wrote:
> > Bernhard Voelker wrote:
> >> b) just adding "ext4" to "ext2/ext3" as it has already been proposed
> >> by several people could break existing scripts that use code like this:
> >>
> >>>       test "$(stat -f -c %T .)" = ext2/ext3 && ...
> >>
> >> I'm wondering how often users check for the hard coded string
> >> "ext2/ext3"? Do we have any numbers?
> 
> > On the surface I don't think the proposed change is particularly
> > scary.
> > [...]
> >
> > As someone with a lot of years and lines of script writing behind me I
> > would always be very paranoid about operations such as "destroy_data"
> > based upon some string value like this.  I like to think that I
> > wouldn't be fooled into a data loss because of something like this.
> > [...]
> 
> That is about the same what I was thinking.
> When someone has written a script managing partitions and file systems,
> then I think he would (hopefully) never just use that well-cited
> snippet to guard existing data against destroying:
> 
>       case $(stat -f --format %T .) in
>         ext2/ext3) ;;
>         *) destroy_partition ;;
>       esac
> 
> First, it's running on Linux or another *NIX flavor, i.e. such
> a script would have to check for many other file system types, too.
> Is that reliable? Probably not.
> 
> Second, I think such a script would probably rely on other things
> rather than using coreutils' stat - e.g. letting the kernel decide
> by trying to "mount -r". Even 'file' knows how to distinguish
> between ext3 and ext4:
> 
>   $ file -s /dev/sdb3
>   /dev/sdb3: Linux rev 1.0 ext3 filesystem data, UUID=<...>, \
>   volume name "home" (needs journal recovery) (large files)
>   $ file -s /dev/sdb2
>   /dev/sdb2: Linux rev 1.0 ext4 filesystem data, UUID=<...>, \
>   volume name "rootfs" (extents) (large files) (huge files)

file uses identifiers for several features (journal, small/large
INCOMPAT and RO_INCOMPAT) to distinguish the ext2 family filesystems. It
should be possible to check for them, but I would expect several dozens
lines of code - which is probably too much for stat code. In addition -
if we go for this, should we change the well established ext2/ext3 to
exact filesystem type, if we recognize it?

> > However because the identifier is an ext2 identifier I would have
> > always reported it as ext2 regardless of whether ext3 or ext4 used it.
> > If there is no way to tell them apart then there is no way to tell.
> > Perhaps better to have reported the raw hex data value of it.
> > 
> > But that is all water under bridge now since the program was imported
> > with that "ext2/ext3" already emitted.  There is no difference in
> > identifier between those and the newer ext4.  I am inclined to say
> > that the identifier is "ext2" now even if ext5 uses it.  What if some
> > new xjzfs uses that same identifier?  It is the identifier that is
> > being reported and not the actual file system contents.  Therefore I
> > wouldn't change it unless the identifier itself is changed.
> 
> Right, stat is just reporting the human readable form of the
> magic number. If that number is used by different file system
> types, then stat should report all possibilities. It's the problem
> of those file systems to use different magic numbers (or not).
> I mean, the ext4 development team has deliberately chosen not to
> use a new number - they will have had their reasons.
> 
> With all that said, I'd +1 the patch.
> WDYT?

Personally, I don't like the ext2/ext3/ext4 approach - simply because it
is too long (and very common). This may break some layout in the scripts
(although I admit badly written). Even with this long form, it will be
not the longest identifier, "minix v2 (30 char.)" is longer, so some
potential overflows of some buffer are again just because of bad
scripts/programs. I don't think that anybody would use the "destroy
other than ext2/ext3 partitions approach" in the script - so this is
more artificial than real life example... still, there might be real
life complains about this longer form.

But even the best one approach - having code to reliably distinguish
between the types - so reporting just ext4 (or ext3) may break some
scripts. ext[234] as well and might be confusing. Same with "ext2
family"...
For me - no good option (even the ext2. ext3 vs. ext4 identification is
not perfect way, may break scripts relying on ext2/ext3 as well)... only
choosing lesser evil...

Greetings,
         Ondrej Vasik





Information forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.

Message received at 13582 <at> debbugs.gnu.org:


Received: (at 13582) by debbugs.gnu.org; 31 Jan 2013 08:03:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 31 03:03:35 2013
Received: from localhost ([127.0.0.1]:56757 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U0p7O-0006rt-Kl
	for submit <at> debbugs.gnu.org; Thu, 31 Jan 2013 03:03:35 -0500
Received: from moutng.kundenserver.de ([212.227.17.10]:57080)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <mail@HIDDEN>) id 1U0p7K-0006rk-Pc
	for 13582 <at> debbugs.gnu.org; Thu, 31 Jan 2013 03:03:32 -0500
Received: from [192.168.1.11] (p5083F782.dip.t-dialin.net [80.131.247.130])
	by mrelayeu.kundenserver.de (node=mreu3) with ESMTP (Nemesis)
	id 0MHvkv-1U009t1Vlt-003anv; Thu, 31 Jan 2013 09:02:48 +0100
Message-ID: <510A2527.2050407@HIDDEN>
Date: Thu, 31 Jan 2013 09:02:47 +0100
From: Bernhard Voelker <mail@HIDDEN>
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
	rv:17.0) Gecko/20130105 Thunderbird/17.0.2
MIME-Version: 1.0
To: Bob Proulx <bob@HIDDEN>
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
	<20130130212750.GA23255@HIDDEN>
	<51099A07.6090704@HIDDEN>
	<20130130224418.GA10314@HIDDEN>
In-Reply-To: <20130130224418.GA10314@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1
Content-Transfer-Encoding: 7bit
X-Provags-ID: V02:K0:aWGVh4ty15IxpUkTdB2mbT+zplyyt3aMhVREcUG210W
	vShLOGeydLNcWvoZUCrUJhBuTMsUUbWErA2nHgCCCc4ymfd2uV
	VIBWX4xOzzBImHll3h0DkL0EA+0YT8Hh+LwNRNninQ26qo5tjc
	h+/KYSh3R4v1BeAJn8yZ6+J2TEF+DDyLXyKrl/lUQP5gghqSjv
	Lh+HPNKTh3F8W+kl84AEJwMH+kTw865saQtzl3kkh3cGb29zWg
	emnHZJjGI0JF7/zfMG5nAUCmRkCn4YN3ULl90/NkV6NbYD6NFW
	tm7BqyJARLmPAwa04h2W0YF5ZaffOy/UmGzRVJj1Yv31PTR3zP
	6P10thnui6PHchmZ63puwvVLJAAl4EbGEg+2DY8Rb
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13582
Cc: 13582 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.0 (/)

On 01/30/2013 11:44 PM, Bob Proulx wrote:
> Bernhard Voelker wrote:
>> b) just adding "ext4" to "ext2/ext3" as it has already been proposed
>> by several people could break existing scripts that use code like this:
>>
>>>       test "$(stat -f -c %T .)" = ext2/ext3 && ...
>>
>> I'm wondering how often users check for the hard coded string
>> "ext2/ext3"? Do we have any numbers?

> On the surface I don't think the proposed change is particularly
> scary.
> [...]
>
> As someone with a lot of years and lines of script writing behind me I
> would always be very paranoid about operations such as "destroy_data"
> based upon some string value like this.  I like to think that I
> wouldn't be fooled into a data loss because of something like this.
> [...]

That is about the same what I was thinking.
When someone has written a script managing partitions and file systems,
then I think he would (hopefully) never just use that well-cited
snippet to guard existing data against destroying:

      case $(stat -f --format %T .) in
        ext2/ext3) ;;
        *) destroy_partition ;;
      esac

First, it's running on Linux or another *NIX flavor, i.e. such
a script would have to check for many other file system types, too.
Is that reliable? Probably not.

Second, I think such a script would probably rely on other things
rather than using coreutils' stat - e.g. letting the kernel decide
by trying to "mount -r". Even 'file' knows how to distinguish
between ext3 and ext4:

  $ file -s /dev/sdb3
  /dev/sdb3: Linux rev 1.0 ext3 filesystem data, UUID=<...>, \
  volume name "home" (needs journal recovery) (large files)
  $ file -s /dev/sdb2
  /dev/sdb2: Linux rev 1.0 ext4 filesystem data, UUID=<...>, \
  volume name "rootfs" (extents) (large files) (huge files)

And third, if such a script really relied on stat, then I think
it would rather use `stat -f --format %t`, i.e. the type in hex,
wouldn't it?


> However because the identifier is an ext2 identifier I would have
> always reported it as ext2 regardless of whether ext3 or ext4 used it.
> If there is no way to tell them apart then there is no way to tell.
> Perhaps better to have reported the raw hex data value of it.
> 
> But that is all water under bridge now since the program was imported
> with that "ext2/ext3" already emitted.  There is no difference in
> identifier between those and the newer ext4.  I am inclined to say
> that the identifier is "ext2" now even if ext5 uses it.  What if some
> new xjzfs uses that same identifier?  It is the identifier that is
> being reported and not the actual file system contents.  Therefore I
> wouldn't change it unless the identifier itself is changed.

Right, stat is just reporting the human readable form of the
magic number. If that number is used by different file system
types, then stat should report all possibilities. It's the problem
of those file systems to use different magic numbers (or not).
I mean, the ext4 development team has deliberately chosen not to
use a new number - they will have had their reasons.

With all that said, I'd +1 the patch.
WDYT?

Have a nice day,
Berny




Information forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.

Message received at 13582 <at> debbugs.gnu.org:


Received: (at 13582) by debbugs.gnu.org; 30 Jan 2013 22:45:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 30 17:45:06 2013
Received: from localhost ([127.0.0.1]:56411 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U0gOv-0008Lp-Qn
	for submit <at> debbugs.gnu.org; Wed, 30 Jan 2013 17:45:06 -0500
Received: from joseki.proulx.com ([216.17.153.58]:51680)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bob@HIDDEN>) id 1U0gOs-0008LM-3b
	for 13582 <at> debbugs.gnu.org; Wed, 30 Jan 2013 17:45:03 -0500
Received: from hysteria.proulx.com (hysteria.proulx.com [192.168.230.119])
	by joseki.proulx.com (Postfix) with ESMTP id 85AF2211D6
	for <13582 <at> debbugs.gnu.org>; Wed, 30 Jan 2013 15:44:18 -0700 (MST)
Received: by hysteria.proulx.com (Postfix, from userid 1000)
	id 4A8EB2DCC0; Wed, 30 Jan 2013 15:44:18 -0700 (MST)
Date: Wed, 30 Jan 2013 15:44:18 -0700
From: Bob Proulx <bob@HIDDEN>
To: 13582 <at> debbugs.gnu.org
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
Message-ID: <20130130224418.GA10314@HIDDEN>
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
	<20130130212750.GA23255@HIDDEN>
	<51099A07.6090704@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <51099A07.6090704@HIDDEN>
User-Agent: Mutt/1.5.21 (2010-09-15)
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 13582
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.3 (/)

Bernhard Voelker wrote:
> Reading (again) through it, it seems to me that we have 2 arguments:
> 
> a) basically, it would be good to be able to distinguish ext2/ext3
> from ext4 while it is problematic in the real world due to EXT4's
> nature - or at least would bring a lot of code into stat.

Yes.  And all of the problems of trying to chase details of every
random filesystem.  It just seems like a bad slippery slope.

> b) just adding "ext4" to "ext2/ext3" as it has already been proposed
> by several people could break existing scripts that use code like this:
> 
> >       test "$(stat -f -c %T .)" = ext2/ext3 && ...
> 
> I'm wondering how often users check for the hard coded string
> "ext2/ext3"? Do we have any numbers?

I haven't had any reason to check for that particular value.  And
therefore for me the question is rather abstract.  It would be very
useful to know the real world reason why people are looking at that
value in order to know what is best to do about it.

On the surface I don't think the proposed change is particularly
scary.  Not as compared to changing head/tail option syntax for
example.  Not as compared to changing regular expression range
interpretation and sort order in different locales for example.  But
both of those have changed in recent history.  This seems quite a bit
more mellow by comparison.

As someone with a lot of years and lines of script writing behind me I
would always be very paranoid about operations such as "destroy_data"
based upon some string value like this.  I like to think that I
wouldn't be fooled into a data loss because of something like this.  I
think changing it would have less impact than adding characters to the
'ls -l' mode display output for example.

However because the identifier is an ext2 identifier I would have
always reported it as ext2 regardless of whether ext3 or ext4 used it.
If there is no way to tell them apart then there is no way to tell.
Perhaps better to have reported the raw hex data value of it.

But that is all water under bridge now since the program was imported
with that "ext2/ext3" already emitted.  There is no difference in
identifier between those and the newer ext4.  I am inclined to say
that the identifier is "ext2" now even if ext5 uses it.  What if some
new xjzfs uses that same identifier?  It is the identifier that is
being reported and not the actual file system contents.  Therefore I
wouldn't change it unless the identifier itself is changed.

Bob




Information forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.

Message received at 13582 <at> debbugs.gnu.org:


Received: (at 13582) by debbugs.gnu.org; 30 Jan 2013 22:09:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 30 17:09:57 2013
Received: from localhost ([127.0.0.1]:56365 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U0fqu-0007Kn-Qg
	for submit <at> debbugs.gnu.org; Wed, 30 Jan 2013 17:09:57 -0500
Received: from moutng.kundenserver.de ([212.227.126.187]:54383)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <mail@HIDDEN>) id 1U0fqq-0007KU-VE
	for 13582 <at> debbugs.gnu.org; Wed, 30 Jan 2013 17:09:55 -0500
Received: from [192.168.1.11] (p5083F782.dip.t-dialin.net [80.131.247.130])
	by mrelayeu.kundenserver.de (node=mreu1) with ESMTP (Nemesis)
	id 0MSmkD-1US0R33eOD-00SUOj; Wed, 30 Jan 2013 23:09:12 +0100
Message-ID: <51099A07.6090704@HIDDEN>
Date: Wed, 30 Jan 2013 23:09:11 +0100
From: Bernhard Voelker <mail@HIDDEN>
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
	rv:17.0) Gecko/20130105 Thunderbird/17.0.2
MIME-Version: 1.0
To: Bob Proulx <bob@HIDDEN>
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
	<20130130212750.GA23255@HIDDEN>
In-Reply-To: <20130130212750.GA23255@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1
Content-Transfer-Encoding: 7bit
X-Provags-ID: V02:K0:lqhLDQe2RQtw2ZUhco1XZEb4GfFhVrcFnpwCtEziRDE
	dlTq1iAfAr3UYEWFMiHJlzuy2CHApgto0GelKedLKRlAuxFYod
	mKioKQWwQrL3huGDpH54SzQ3kQ6i/Y4RpeK/aZfvBfFWq9SSAA
	f2yMXsqmsRJQOXZ+hYF3iQV31EANdPuocE4JazH8IkoN8FrdL0
	PRI7WIuXB5fLqqf5GO6wasm/ynDhgo7cpCoaqUfrSChiOtoyK1
	nmwxiYpRJPVFbtxaxu8TJpWVSiOGigDM5lgiNEn8fYpoig8Fb8
	Jhx59WZocfPkoPFke8+YO8FRj4z+v1ymXEcBYsgkFexwi7mPoV
	mFTLG8ySTNgJkONl6NmfE5BkIGeaCCpXWSbq0VmUS
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13582
Cc: 13582 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.0 (/)

On 01/30/2013 10:27 PM, Bob Proulx wrote:
> I am just adding references here to tie in the previous discussions.

Thanks for that excellent summary.

Reading (again) through it, it seems to me that we have 2 arguments:

a) basically, it would be good to be able to distinguish ext2/ext3
from ext4 while it is problematic in the real world due to EXT4's
nature - or at least would bring a lot of code into stat.

b) just adding "ext4" to "ext2/ext3" as it has already been proposed
by several people could break existing scripts that use code like this:

>       test "$(stat -f -c %T .)" = ext2/ext3 && ...

I'm wondering how often users check for the hard coded string
"ext2/ext3"? Do we have any numbers?

Have a nice day,
Berny




Information forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.

Message received at 13582 <at> debbugs.gnu.org:


Received: (at 13582) by debbugs.gnu.org; 30 Jan 2013 21:28:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 30 16:28:35 2013
Received: from localhost ([127.0.0.1]:56327 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U0fCt-0005O3-4M
	for submit <at> debbugs.gnu.org; Wed, 30 Jan 2013 16:28:35 -0500
Received: from joseki.proulx.com ([216.17.153.58]:51408)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bob@HIDDEN>) id 1U0fCo-0005Nr-Pz
	for 13582 <at> debbugs.gnu.org; Wed, 30 Jan 2013 16:28:32 -0500
Received: from hysteria.proulx.com (hysteria.proulx.com [192.168.230.119])
	by joseki.proulx.com (Postfix) with ESMTP id 56AFC211D6
	for <13582 <at> debbugs.gnu.org>; Wed, 30 Jan 2013 14:27:51 -0700 (MST)
Received: by hysteria.proulx.com (Postfix, from userid 1000)
	id 031A02DCC0; Wed, 30 Jan 2013 14:27:50 -0700 (MST)
Date: Wed, 30 Jan 2013 14:27:50 -0700
From: Bob Proulx <bob@HIDDEN>
To: 13582 <at> debbugs.gnu.org
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
Message-ID: <20130130212750.GA23255@HIDDEN>
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
User-Agent: Mutt/1.5.21 (2010-09-15)
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 13582
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.4 (--)

I am just adding references here to tie in the previous discussions.

The bugzilla.redhat.com discussion actually has the best analysis of
the problem.  However let me summarize (and plagarize) as best as I
can here.

In https://bugzilla.redhat.com/show_bug.cgi?id=485507

  Eric Sandeen proposed to add ext4 to the list of names
  currently reported for that type of file system ("ext2/ext3").

In response Jim stated:

  http://lists.gnu.org/archive/html/bug-coreutils/2009-02/msg00160.html

  I'm reluctant to change that string, because doing so might
  well break scripts that rely on them:

      case $(stat -f --format %T .) in
        ext2/ext3) ;;
        *) destroy_partition ;;
      esac

  Sure, script writers might well anticipate this and
  prefer to use the %t directive to get the type in hexadecimal,
  but that's far less readable.

  How much code (and how ugly) would be required to distinguish ext4
  from ext[23]?

This was further reinforced by Jim in a later discussion:

  http://lists.gnu.org/archive/html/bug-coreutils/2009-12/msg00229.html

  For the ext4-adding part, I'm a little reluctant,
  because it may break scripts that test via e.g.,

      test "$(stat -f -c %T .)" = ext2/ext3 && ...

  rather than the more portable -- in potential retrospect:

      case $(stat -f -c %T .) in
          ext2/ext3*) ... ;
      esac

In the previous thread Eric suggested some pseudo-code flow to
distinguish ext4 from ext* but it would have needed significant effort
to complete.  This was followed up in the in the bugzilla trail
especially this where we see that the problem of distinguishing ext4
is not trivial and opens a box of problems.  I think it is worthwhile
to share it here.

  https://bugzilla.redhat.com/show_bug.cgi?id=485507#c7
  Eric Sandeen 2012-04-25 17:05:14 EDT

  A big part of the problem is that "ext4" is a big, random collection
  of features.  It's more a new driver codebase containing various &
  sundry new things, than a fixed on-disk format.

  You can turn any/all of the following on or off and mount it with the
  ext4 driver:

  * extents
  * delalloc
  * flex_bg
  * journaling
  * 64-bitness
  * "bigalloc"
  * .... etc ....

  So the question becomes, what exactly _is_ ext4?  Best we can do is
  "ext2/3/4" or so, I think.

  https://bugzilla.redhat.com/show_bug.cgi?id=485507#c8
  Ondrej Vasik 2012-04-25 19:33:20 EDT

  But upstream (Jim Meyering) already rejected ext2/3/4 change - as it
  may break scripts - and recognizing ext4 based on some feature might
  be a tricky thing - as Eric mentioned - and will polute the stat
  code. Bad luck that ext2/3/4 uses the same magic for all filesystems.

  https://bugzilla.redhat.com/show_bug.cgi?id=485507#c9
  Eric Sandeen 2012-04-25 20:08:06 EDT

  Best to close it WONTFIX then, I guess?

  https://bugzilla.redhat.com/show_bug.cgi?id=485507#c10
  Ondrej Vasik 2012-04-26 02:06:03 EDT

  Probably... closing WONTFIX, anyone - feel free to reopen it if you
  find an easy way how to reliably distinguish ext2/3 and ext4
  filesystem (or just propose it as reply in upstream thread mentioned
  in comment #4 or #5 - as this possible change has to be done/accepted
  upstream). These ways I'm aware of are too big for stat.c code.

I think the above rationale is still a good place to start.  It is
unfortunate that ext4 is using the same identifier as ext3.  And the
same that ext3 used the same identifier as ext2.

Bob




Information forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.
Severity set to 'wishlist' from 'normal' Request was from Bob Proulx <bob@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Did not alter fixed versions and reopened. Request was from Debbugs Internal Request <help-debbugs@HIDDEN> to internal_control <at> debbugs.gnu.org. Full text available.

Message received at 13582 <at> debbugs.gnu.org:


Received: (at 13582) by debbugs.gnu.org; 30 Jan 2013 20:52:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 30 15:52:55 2013
Received: from localhost ([127.0.0.1]:56270 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U0eeN-0003fb-1y
	for submit <at> debbugs.gnu.org; Wed, 30 Jan 2013 15:52:55 -0500
Received: from joseki.proulx.com ([216.17.153.58]:51205)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bob@HIDDEN>)
	id 1U0eeK-0003fR-Je; Wed, 30 Jan 2013 15:52:54 -0500
Received: from hysteria.proulx.com (hysteria.proulx.com [192.168.230.119])
	by joseki.proulx.com (Postfix) with ESMTP id 74B21211D6;
	Wed, 30 Jan 2013 13:52:13 -0700 (MST)
Received: by hysteria.proulx.com (Postfix, from userid 1000)
	id 4F5362DCC0; Wed, 30 Jan 2013 13:52:13 -0700 (MST)
Date: Wed, 30 Jan 2013 13:52:13 -0700
From: Bob Proulx <bob@HIDDEN>
To: 13582 <at> debbugs.gnu.org
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
Message-ID: <20130130205213.GA16391@HIDDEN>
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
	<510772E6.3050906@HIDDEN>
	<201301291339.43815.vapier@HIDDEN>
	<51082EE8.1050006@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <51082EE8.1050006@HIDDEN>
User-Agent: Mutt/1.5.21 (2010-09-15)
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 13582
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.3 (/)

reopen 13582
severity 13582 wishlist
thanks

Bernhard Voelker wrote:
> I feel very sorry if my words were a bit harsh.
> 
> Admitted, you refer to this in README:
> 
>   If your patch adds a new feature, please try to get some sort of consensus
>   that it is a worthwhile change.  One way to do that is to send mail to
>   bug-coreutils@HIDDEN including as much description and justification
>   as you can.  Based on the feedback that generates, you may be able to
>   convince us that it's worth adding.

I think that text should be updated to reflect the current positioning
of the bug tracker behind the bug-coreutils address.  Let's do that in
a separate discussion not in this one about stat and ext*.

> Hmm, in my opinion and what I have experienced in the last 2+ year
> on the coreutils and bug-coreutils mailing lists, real bugs (or if
> the user thinks it is one) should be handled in bug-coreutils, while
> general discussion issues and topics including patches which need some
> consensus (or review) should go to the main coreutils mailing list.
> 
> But as Bob also stated off-list, your patch is some corner case:
> 
>   But it is a grey area needing a judgement call.  Certainly a
>   submission that is simply, "what do you think about this" would
>   be a discussion issue.
> 
> Sorry again.

And I had also said this there too:

  I think it is okay to have actual patch submissions open tickets for
  tracking.  Those are pretty rare in general.  When they implement
  features they can be marked as a wishlist item.  If that feature is
  decided not to be done then they can be marked as "wontfix".  For this
  particular item I think that may be more appropriate as the topic has
  come up more than once.

And so I have done that.  I didn't tag it wontfix because I am not
sure the discussion is complete to concensus yet.  Perhaps some
different but better behavior will result.

Bob




Information forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.

Message received at 13582-done <at> debbugs.gnu.org:


Received: (at 13582-done) by debbugs.gnu.org; 29 Jan 2013 20:20:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 29 15:20:50 2013
Received: from localhost ([127.0.0.1]:54686 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U0Hfl-0004Ub-9e
	for submit <at> debbugs.gnu.org; Tue, 29 Jan 2013 15:20:50 -0500
Received: from moutng.kundenserver.de ([212.227.126.186]:53420)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <mail@HIDDEN>) id 1U0Hfe-0004UP-ST
	for 13582-done <at> debbugs.gnu.org; Tue, 29 Jan 2013 15:20:47 -0500
Received: from [192.168.1.11] (p5083F782.dip.t-dialin.net [80.131.247.130])
	by mrelayeu.kundenserver.de (node=mreu3) with ESMTP (Nemesis)
	id 0LaNXn-1Ui5v43CyF-00mJQR; Tue, 29 Jan 2013 21:19:53 +0100
Message-ID: <51082EE8.1050006@HIDDEN>
Date: Tue, 29 Jan 2013 21:19:52 +0100
From: Bernhard Voelker <mail@HIDDEN>
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
	rv:17.0) Gecko/20130105 Thunderbird/17.0.2
MIME-Version: 1.0
To: Mike Frysinger <vapier@HIDDEN>
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
	<510772E6.3050906@HIDDEN>
	<201301291339.43815.vapier@HIDDEN>
In-Reply-To: <201301291339.43815.vapier@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1
Content-Transfer-Encoding: 7bit
X-Provags-ID: V02:K0:WYeyc3iWShlS++YNGXRvh62ldLBQcqTEyx8omYa0uf7
	yA38hckGkRouvFsMEAiEQcz8Vrrs2cNQ1Is4UKtGfXihvqKCJk
	cAE02bvRAU9etxe7m1UhgJnolxO/gI8pzzfT6rZIVSGLvWvWgD
	PGxctfaVNteRezIct4bRNY89++zj9mCG+b+skuEUbTQW2wHRAX
	Nifb3uCt1Rg/qYz39APFtIi3YXIqB2+SNp7jcK0BqDEW9QzyJD
	sWk3GdATSW182FvwMTRYct64/oma2aIT49H7cZDr/E+sIMNrzn
	1wbmB7e8vb0r9PmNvXZcrmyID2712IZ5d7OTOqfFZwvsP1+ohA
	BHuDy8V4CMWK5y2dPnxlcwNzWMSYNFDPp1cbh5qW2
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13582-done
Cc: 13582-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.0 (/)

On 01/29/2013 07:39 PM, Mike Frysinger wrote:> On Tuesday 29 January 2013 01:57:42 Bernhard Voelker wrote:
>> On 01/29/2013 07:13 AM, Mike Frysinger wrote:
>> Thanks for the patch, however, you submitted it to the bug-coreutils
>> mailing list which automatically opened a new ticket. Therefore, I'm
>> closing the bug (not intending to stop the discussion). Please use the
>> general discussion list coreutils@HIDDEN next time.
> 
> that's not really what the top level README files indicate in the coreutils 
> repo

Hi Mike,

I feel very sorry if my words were a bit harsh.

Admitted, you refer to this in README:

  If your patch adds a new feature, please try to get some sort of consensus
  that it is a worthwhile change.  One way to do that is to send mail to
  bug-coreutils@HIDDEN including as much description and justification
  as you can.  Based on the feedback that generates, you may be able to
  convince us that it's worth adding.

Hmm, in my opinion and what I have experienced in the last 2+ year
on the coreutils and bug-coreutils mailing lists, real bugs (or if
the user thinks it is one) should be handled in bug-coreutils, while
general discussion issues and topics including patches which need some
consensus (or review) should go to the main coreutils mailing list.

But as Bob also stated off-list, your patch is some corner case:

  But it is a grey area needing a judgement call.  Certainly a
  submission that is simply, "what do you think about this" would
  be a discussion issue.

Sorry again.

Back to EXT*:
I think one problem is that an ext2 or ext3 file system can be mounted
as ext2, ext3, or ext4, while an ext4 file system can only be mounted
as ext4, not as ext2/ext3. Therefore, a detection of the real type would
probably be worthwhile. OTOH a running program may not need to care about
how this file system could be mounted otherwise.

Have a nice day,
Berny




Information forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.

Message received at 13582-done <at> debbugs.gnu.org:


Received: (at 13582-done) by debbugs.gnu.org; 29 Jan 2013 18:40:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 29 13:40:21 2013
Received: from localhost ([127.0.0.1]:54653 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U0G6W-00023U-TY
	for submit <at> debbugs.gnu.org; Tue, 29 Jan 2013 13:40:21 -0500
Received: from smtp.gentoo.org ([140.211.166.183]:50060)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <vapier@HIDDEN>) id 1U0G6U-00023L-2B
	for 13582-done <at> debbugs.gnu.org; Tue, 29 Jan 2013 13:40:19 -0500
Received: from vapier.localnet (localhost [127.0.0.1])
	by smtp.gentoo.org (Postfix) with ESMTP id 26C1333DA95;
	Tue, 29 Jan 2013 18:39:44 +0000 (UTC)
From: Mike Frysinger <vapier@HIDDEN>
Organization: wh0rd.org
To: Bernhard Voelker <mail@HIDDEN>
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
Date: Tue, 29 Jan 2013 13:39:42 -0500
User-Agent: KMail/1.13.7 (Linux/3.7.1; KDE/4.6.5; x86_64; ; )
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
	<510772E6.3050906@HIDDEN>
In-Reply-To: <510772E6.3050906@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="nextPart1404015.HVbsFKKHVF";
	protocol="application/pgp-signature"; micalg=pgp-sha1
Content-Transfer-Encoding: 7bit
Message-Id: <201301291339.43815.vapier@HIDDEN>
X-Spam-Score: -4.7 (----)
X-Debbugs-Envelope-To: 13582-done
Cc: 13582-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.7 (----)

--nextPart1404015.HVbsFKKHVF
Content-Type: Text/Plain;
  charset="iso-8859-1"
Content-Transfer-Encoding: quoted-printable

On Tuesday 29 January 2013 01:57:42 Bernhard Voelker wrote:
> tag 13582 + notabug
> close 13582
> stop
>=20
> On 01/29/2013 07:13 AM, Mike Frysinger wrote:
> > Since ext4 returns the same info as ext2/ext3, add it to the list.
> > This fixes the output of running `stat -f / -c %T` on my system that
> > has an ext4 rootfs.
>=20
> Thanks for the patch, however, you submitted it to the bug-coreutils
> mailing list which automatically opened a new ticket. Therefore, I'm
> closing the bug (not intending to stop the discussion). Please use the
> general discussion list coreutils@HIDDEN next time.

that's not really what the top level README files indicate in the coreutils=
=20
repo
=2Dmike

--nextPart1404015.HVbsFKKHVF
Content-Type: application/pgp-signature; name=signature.asc 
Content-Description: This is a digitally signed message part.

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v2.0.17 (GNU/Linux)

iQIcBAABAgAGBQJRCBdvAAoJEEFjO5/oN/WB3GAP/0unOe6foAU/YgHW+UhGbuRd
/0OAI/lwbzykF6d2iB50nLDaJAJtpywAMncxIkyyltbfdubLWgUmJxpQhNRxvU8i
h6m0JnZ0X1diZueQDRamPAKocqmyZWCB0Zed9tCp0oR5TakMUANEYQAnu4P1dZGa
UMvrH9vADUR03Y1k0dGomWi+LJ1nZodgxHdnFBJVJlLWeN2B1BSJyojT/KD316IJ
ngLzrgURRAacXHKRLOWVhq3ibH+AGp9IZ6cyDQhV8a/WEJ4I2/9d+Mc/SlkwiYFo
afCTKvwGklxuPS13lw+mkrxXVg9Uao+Vt8G+b3jlRi/8QEf52hvUpR1mohmz00bS
iK//RdsjXJF2m373nkPGNDKSY9c+uDuAAuaj5mcHoAjXPiqsJbQAHpZxDCp1VOMJ
hUvHep0lSbn6aZ6ZUUSwlagwcnUdKgmMSZOBz7FzKbkTqy8KmFAUVzMqub94uxf/
rQIoxXZ654l6m1dAFFqcycx/KD1eeu8bAlGZUpBIpnSFRP7A/7sQC+BEFbEnH/T6
Z0ii6JJMexF1cZMAWzpLQroMx4X3bNjKXach/r0J2AmwtYDxoSd/nFfsMKWc9b89
M+V1F1AnrDnrHz2D2OMKy9jmfndkWWP8rRHqdRrq9MeEw48ZWVCfCeuWOUYZKlO0
QhYXOf7KkTEFXze7NBsG
=PLmJ
-----END PGP SIGNATURE-----

--nextPart1404015.HVbsFKKHVF--




Information forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.

Message received at 13582-done <at> debbugs.gnu.org:


Received: (at 13582-done) by debbugs.gnu.org; 29 Jan 2013 06:58:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 29 01:58:21 2013
Received: from localhost ([127.0.0.1]:53516 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U0597-0001cE-Tq
	for submit <at> debbugs.gnu.org; Tue, 29 Jan 2013 01:58:20 -0500
Received: from moutng.kundenserver.de ([212.227.126.171]:61255)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <mail@HIDDEN>) id 1U0594-0001c4-Jv
	for 13582-done <at> debbugs.gnu.org; Tue, 29 Jan 2013 01:58:15 -0500
Received: from [192.168.1.11] (p5083F782.dip.t-dialin.net [80.131.247.130])
	by mrelayeu.kundenserver.de (node=mreu1) with ESMTP (Nemesis)
	id 0LckOB-1UgGAa38q7-00jTIX; Tue, 29 Jan 2013 07:57:43 +0100
Message-ID: <510772E6.3050906@HIDDEN>
Date: Tue, 29 Jan 2013 07:57:42 +0100
From: Bernhard Voelker <mail@HIDDEN>
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
	rv:17.0) Gecko/20130105 Thunderbird/17.0.2
MIME-Version: 1.0
To: Mike Frysinger <vapier@HIDDEN>
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
In-Reply-To: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1
Content-Transfer-Encoding: 7bit
X-Provags-ID: V02:K0:mEjFKTAUyu4FTBXctGgQE869/rhdvQDN99e2KSkP3tb
	uSjl9NYCTh4pUfT4DYhu984mnTld8jE7DpKuzDCpvGlGbwX8bQ
	IILYI+I0ur/PHIZ1xdaE6lTA50GD9b/OgHbCobddNJvD6/qiRF
	y8YD9qiMpJ467KUCsv4qppNUcI69pVnNGs5hT1n9ViEVKLFeH9
	hBuVGOqwGUOP9JcxuMbbykW0Kf+qkkJGWYecWrzCkDc5/lPXyG
	H9DxlIL7mCGXCOwZsd5kiLH721RiHM7g52c8JO5lzksyW8wVky
	8RjOAK3Pxs6K3VPGbVZ4ktcFLyFv0+1PmBajvr6SkvwPDo0Mka
	2REdWmHfacFuc0qTQfRzpaljEAXcpUaCEe03rqPQn
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13582-done
Cc: 13582-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.0 (/)

tag 13582 + notabug
close 13582
stop

On 01/29/2013 07:13 AM, Mike Frysinger wrote:
> Since ext4 returns the same info as ext2/ext3, add it to the list.
> This fixes the output of running `stat -f / -c %T` on my system that
> has an ext4 rootfs.

Thanks for the patch, however, you submitted it to the bug-coreutils
mailing list which automatically opened a new ticket. Therefore, I'm
closing the bug (not intending to stop the discussion). Please use the
general discussion list coreutils@HIDDEN next time.


Re. EXT4:
this has been discussed recently:
http://lists.gnu.org/archive/html/coreutils/2012-12/msg00068.html

Have a nice day,
Berny




Notification sent to Mike Frysinger <vapier@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Bernhard Voelker <mail@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 13582 <at> debbugs.gnu.org:


Received: (at 13582) by debbugs.gnu.org; 29 Jan 2013 06:47:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 29 01:47:35 2013
Received: from localhost ([127.0.0.1]:53507 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U04yj-0001ND-7k
	for submit <at> debbugs.gnu.org; Tue, 29 Jan 2013 01:47:34 -0500
Received: from joseki.proulx.com ([216.17.153.58]:43310)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bob@HIDDEN>) id 1U04ye-0001Ms-7v
	for 13582 <at> debbugs.gnu.org; Tue, 29 Jan 2013 01:47:30 -0500
Received: from hysteria.proulx.com (hysteria.proulx.com [192.168.230.119])
	by joseki.proulx.com (Postfix) with ESMTP id 2E7E1211D6;
	Mon, 28 Jan 2013 23:46:55 -0700 (MST)
Received: by hysteria.proulx.com (Postfix, from userid 1000)
	id 6B45A2DCC0; Mon, 28 Jan 2013 23:46:54 -0700 (MST)
Date: Mon, 28 Jan 2013 23:46:54 -0700
From: Bob Proulx <bob@HIDDEN>
To: Mike Frysinger <vapier@HIDDEN>
Subject: Re: bug#13582: [PATCH] stat: add ext4 to the ext2/ext3 list
Message-ID: <20130129064653.GA13398@HIDDEN>
References: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
User-Agent: Mutt/1.5.21 (2010-09-15)
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 13582
Cc: 13582 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.0 (-)

Mike Frysinger wrote:
> Since ext4 returns the same info as ext2/ext3, add it to the list.
> This fixes the output of running `stat -f / -c %T` on my system that
> has an ext4 rootfs.
> 
> * src/stat.c (human_fstype): Add "ext4" to the S_MAGIC_EXT2 and
> FSTYPE_EXT2FS cases.

Previous discussion (wow, three years ago now):

  http://lists.gnu.org/archive/html/bug-coreutils/2009-02/msg00160.html

Bob




Information forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 29 Jan 2013 06:14:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 29 01:14:05 2013
Received: from localhost ([127.0.0.1]:53483 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U04SL-0000Yo-9L
	for submit <at> debbugs.gnu.org; Tue, 29 Jan 2013 01:14:05 -0500
Received: from eggs.gnu.org ([208.118.235.92]:51002)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <vapier@HIDDEN>) id 1U04SI-0000Yg-J5
	for submit <at> debbugs.gnu.org; Tue, 29 Jan 2013 01:14:03 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <vapier@HIDDEN>) id 1U04Ro-0007rs-3p
	for submit <at> debbugs.gnu.org; Tue, 29 Jan 2013 01:13:32 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-107.4 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_HI, 
	RP_MATCHES_RCVD,
	USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:36474)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <vapier@HIDDEN>) id 1U04Ro-0007ro-18
	for submit <at> debbugs.gnu.org; Tue, 29 Jan 2013 01:13:32 -0500
Received: from eggs.gnu.org ([208.118.235.92]:34131)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <vapier@HIDDEN>) id 1U04Rn-0008P9-0V
	for bug-coreutils@HIDDEN; Tue, 29 Jan 2013 01:13:31 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <vapier@HIDDEN>) id 1U04Rm-0007rS-1b
	for bug-coreutils@HIDDEN; Tue, 29 Jan 2013 01:13:30 -0500
Received: from smtp.gentoo.org ([140.211.166.183]:46193)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <vapier@HIDDEN>) id 1U04Rl-0007rO-Rh
	for bug-coreutils@HIDDEN; Tue, 29 Jan 2013 01:13:29 -0500
Received: from localhost.localdomain (localhost [127.0.0.1])
	by smtp.gentoo.org (Postfix) with ESMTP id 8BD8A33DBC6
	for <bug-coreutils@HIDDEN>; Tue, 29 Jan 2013 06:13:28 +0000 (UTC)
From: Mike Frysinger <vapier@HIDDEN>
To: bug-coreutils@HIDDEN
Subject: [PATCH] stat: add ext4 to the ext2/ext3 list
Date: Tue, 29 Jan 2013 01:13:49 -0500
Message-Id: <1359440029-19161-1-git-send-email-vapier@HIDDEN>
X-Mailer: git-send-email 1.8.0.2
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -3.4 (---)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.1 (------)

Since ext4 returns the same info as ext2/ext3, add it to the list.
This fixes the output of running `stat -f / -c %T` on my system that
has an ext4 rootfs.

* src/stat.c (human_fstype): Add "ext4" to the S_MAGIC_EXT2 and
FSTYPE_EXT2FS cases.
---
 src/stat.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/stat.c b/src/stat.c
index dd210d1..d3d7190 100644
--- a/src/stat.c
+++ b/src/stat.c
@@ -293,7 +293,7 @@ human_fstype (STRUCT_STATVFS const *statfsbuf)
     case S_MAGIC_EXT: /* 0x137D local */
       return "ext";
     case S_MAGIC_EXT2: /* 0xEF53 local */
-      return "ext2/ext3";
+      return "ext2/ext3/ext4";
     case S_MAGIC_EXT2_OLD: /* 0xEF51 local */
       return "ext2";
     case S_MAGIC_FAT: /* 0x4006 local */
@@ -480,7 +480,7 @@ human_fstype (STRUCT_STATVFS const *statfsbuf)
     case FSTYPE_MISC:
       return "misc";
     case FSTYPE_EXT2FS:
-      return "ext2/ext3";
+      return "ext2/ext3/ext4";
     case FSTYPE_HTTP:
       return "http";
     case FSTYPE_MEMFS:
-- 
1.8.0.2





Acknowledgement sent to Mike Frysinger <vapier@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-coreutils@HIDDEN. Full text available.
Report forwarded to bug-coreutils@HIDDEN:
bug#13582; Package coreutils. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.